/*
 =================== DO NOT EDIT THIS FILE ====================
 Generated by Modello 1.6 on 2012-12-19 15:37:07,
 any modifications will be overwritten.
 ==============================================================
 */

package org.sonatype.nexus.configuration.model.v1_0_3;

/**
 * The Nexus repository model.
 * 
 * @version $Revision$ $Date$
 */
@SuppressWarnings( "all" )
public class CRepository
    implements java.io.Serializable
{

      //--------------------------/
     //- Class/Member Variables -/
    //--------------------------/

    /**
     * Repository ID. It should uniquely identify this repository
     * across Nexus.
     */
    private String id;

    /**
     * Human readable Repository name.
     */
    private String name;

    /**
     * The local status of repository.
     */
    private String localStatus = "inService";

    /**
     * The proxyMode of repository.
     */
    private String proxyMode = "allow";

    /**
     * The type of repository.
     */
    private String type = "maven2";

    /**
     * 
     *             If true, repository will deny any kind of
     * deployment (write) request. Caching will still work.
     *           
     */
    private boolean allowWrite = false;

    /**
     * 
     *             If true, repository is browseable on UI/DAV.
     * With any value repository will still properly serve
     *             Maven
     *             clients.
     *           
     */
    private boolean browseable = true;

    /**
     * 
     *             If true, repository will get indexed. If false,
     * the files and artifacts from repository will NOT
     *             appear on Nexus
     *             index, thus will be not searcheable (and
     * browseable on views that relies on
     *             index), altough it will
     *             serve Maven clients properly.
     *           
     */
    private boolean indexable = true;

    /**
     * 
     *             NotFoundCache, the neg-cache records time to
     * live in minutes. How long will misses be cached.
     *           
     */
    private int notFoundCacheTTL = 1440;

    /**
     * 
     *             Max. minutes that have to pass before Nexus will
     * look to remote peer for possibly new version of
     *             artifact.
     *           
     */
    private int artifactMaxAge = 1440;

    /**
     * 
     *             Max. minutes that have to pass before Nexus will
     * look to remote peer for possibly new version of
     *             repository metadata.
     *           
     */
    private int metadataMaxAge = 1440;

    /**
     * 
     *             If true, repository will fix/maintain repository
     * metadata (according to it's repositoryType)
     *             that is
     *             coming from it's
     *             remote store (this setting does not affect
     * hosted reposes). Beware,
     *             this setting is modifying the
     *             repo metadata!
     *           
     */
    private boolean maintainProxiedRepositoryMetadata = false;

    /**
     * 
     *             The type of repository, it may have "release" or
     * "snapshot" values allowing it to
     *             host/proxy/server
     *             release or snapshot
     *             artifacts only.
     *           
     */
    private String repositoryPolicy = "release";

    /**
     * 
     *             The checksum policy of this repository (used on
     * proxies only). Valid values are: 'ignore'
     *             (simply
     *             ignore checksums),
     *             'warn' (warn in logs on wrong checksums but
     * serve it), 'strict'
     *             (strict checksumming, on bad or
     *             missing remote checksum the
     *             artifact is not served) and
     *             'strictIfExists' (like 'strict' if hash exists
     * remotely or
     *             warn if not exists).
     *           
     */
    private String checksumPolicy = "warn";

    /**
     * If this repo is Proxy, should we download remote indexes?
     */
    private boolean downloadRemoteIndexes = false;

    /**
     * The ID of defined realm from "security" section of
     * configuration.
     */
    private String realmId;

    /**
     * 
     *             The local storage definition of repository. It
     * is optional element. If not defined, the
     *             repository will
     *             use the shared
     *             local storage.
     *           
     */
    private CLocalStorage localStorage;

    /**
     * 
     *             The remote storage definition of repository. It
     * not defined, the repository will be
     *             Nexus-hosted. If
     *             defined at least
     *             the remote URL, the repository will be
     * proxy-repository.
     *           
     */
    private CRemoteStorage remoteStorage;


      //-----------/
     //- Methods -/
    //-----------/

    /**
     * Get max. minutes that have to pass before Nexus will look to
     * remote peer for possibly new version of
     *             artifact.
     * 
     * @return int
     */
    public int getArtifactMaxAge()
    {
        return this.artifactMaxAge;
    } //-- int getArtifactMaxAge()

    /**
     * Get the checksum policy of this repository (used on proxies
     * only). Valid values are: 'ignore'
     *             (simply
     *             ignore checksums),
     *             'warn' (warn in logs on wrong checksums but
     * serve it), 'strict'
     *             (strict checksumming, on bad or
     *             missing remote checksum the
     *             artifact is not served) and
     *             'strictIfExists' (like 'strict' if hash exists
     * remotely or
     *             warn if not exists).
     * 
     * @return String
     */
    public String getChecksumPolicy()
    {
        return this.checksumPolicy;
    } //-- String getChecksumPolicy()

    /**
     * Get repository ID. It should uniquely identify this
     * repository across Nexus.
     * 
     * @return String
     */
    public String getId()
    {
        return this.id;
    } //-- String getId()

    /**
     * Get the local status of repository.
     * 
     * @return String
     */
    public String getLocalStatus()
    {
        return this.localStatus;
    } //-- String getLocalStatus()

    /**
     * Get the local storage definition of repository. It is
     * optional element. If not defined, the
     *             repository will
     *             use the shared
     *             local storage.
     * 
     * @return CLocalStorage
     */
    public CLocalStorage getLocalStorage()
    {
        return this.localStorage;
    } //-- CLocalStorage getLocalStorage()

    /**
     * Get max. minutes that have to pass before Nexus will look to
     * remote peer for possibly new version of
     *             repository metadata.
     * 
     * @return int
     */
    public int getMetadataMaxAge()
    {
        return this.metadataMaxAge;
    } //-- int getMetadataMaxAge()

    /**
     * Get human readable Repository name.
     * 
     * @return String
     */
    public String getName()
    {
        return this.name;
    } //-- String getName()

    /**
     * Get notFoundCache, the neg-cache records time to live in
     * minutes. How long will misses be cached.
     * 
     * @return int
     */
    public int getNotFoundCacheTTL()
    {
        return this.notFoundCacheTTL;
    } //-- int getNotFoundCacheTTL()

    /**
     * Get the proxyMode of repository.
     * 
     * @return String
     */
    public String getProxyMode()
    {
        return this.proxyMode;
    } //-- String getProxyMode()

    /**
     * Get the ID of defined realm from "security" section of
     * configuration.
     * 
     * @return String
     */
    public String getRealmId()
    {
        return this.realmId;
    } //-- String getRealmId()

    /**
     * Get the remote storage definition of repository. It not
     * defined, the repository will be
     *             Nexus-hosted. If
     *             defined at least
     *             the remote URL, the repository will be
     * proxy-repository.
     * 
     * @return CRemoteStorage
     */
    public CRemoteStorage getRemoteStorage()
    {
        return this.remoteStorage;
    } //-- CRemoteStorage getRemoteStorage()

    /**
     * Get the type of repository, it may have "release" or
     * "snapshot" values allowing it to
     *             host/proxy/server
     *             release or snapshot
     *             artifacts only.
     * 
     * @return String
     */
    public String getRepositoryPolicy()
    {
        return this.repositoryPolicy;
    } //-- String getRepositoryPolicy()

    /**
     * Get the type of repository.
     * 
     * @return String
     */
    public String getType()
    {
        return this.type;
    } //-- String getType()

    /**
     * Get if true, repository will deny any kind of deployment
     * (write) request. Caching will still work.
     * 
     * @return boolean
     */
    public boolean isAllowWrite()
    {
        return this.allowWrite;
    } //-- boolean isAllowWrite()

    /**
     * Get if true, repository is browseable on UI/DAV. With any
     * value repository will still properly serve
     *             Maven
     *             clients.
     * 
     * @return boolean
     */
    public boolean isBrowseable()
    {
        return this.browseable;
    } //-- boolean isBrowseable()

    /**
     * Get if this repo is Proxy, should we download remote
     * indexes?
     * 
     * @return boolean
     */
    public boolean isDownloadRemoteIndexes()
    {
        return this.downloadRemoteIndexes;
    } //-- boolean isDownloadRemoteIndexes()

    /**
     * Get if true, repository will get indexed. If false, the
     * files and artifacts from repository will NOT
     *             appear on Nexus
     *             index, thus will be not searcheable (and
     * browseable on views that relies on
     *             index), altough it will
     *             serve Maven clients properly.
     * 
     * @return boolean
     */
    public boolean isIndexable()
    {
        return this.indexable;
    } //-- boolean isIndexable()

    /**
     * Get if true, repository will fix/maintain repository
     * metadata (according to it's repositoryType)
     *             that is
     *             coming from it's
     *             remote store (this setting does not affect
     * hosted reposes). Beware,
     *             this setting is modifying the
     *             repo metadata!
     * 
     * @return boolean
     */
    public boolean isMaintainProxiedRepositoryMetadata()
    {
        return this.maintainProxiedRepositoryMetadata;
    } //-- boolean isMaintainProxiedRepositoryMetadata()

    /**
     * Set if true, repository will deny any kind of deployment
     * (write) request. Caching will still work.
     * 
     * @param allowWrite
     */
    public void setAllowWrite( boolean allowWrite )
    {
        this.allowWrite = allowWrite;
    } //-- void setAllowWrite( boolean )

    /**
     * Set max. minutes that have to pass before Nexus will look to
     * remote peer for possibly new version of
     *             artifact.
     * 
     * @param artifactMaxAge
     */
    public void setArtifactMaxAge( int artifactMaxAge )
    {
        this.artifactMaxAge = artifactMaxAge;
    } //-- void setArtifactMaxAge( int )

    /**
     * Set if true, repository is browseable on UI/DAV. With any
     * value repository will still properly serve
     *             Maven
     *             clients.
     * 
     * @param browseable
     */
    public void setBrowseable( boolean browseable )
    {
        this.browseable = browseable;
    } //-- void setBrowseable( boolean )

    /**
     * Set the checksum policy of this repository (used on proxies
     * only). Valid values are: 'ignore'
     *             (simply
     *             ignore checksums),
     *             'warn' (warn in logs on wrong checksums but
     * serve it), 'strict'
     *             (strict checksumming, on bad or
     *             missing remote checksum the
     *             artifact is not served) and
     *             'strictIfExists' (like 'strict' if hash exists
     * remotely or
     *             warn if not exists).
     * 
     * @param checksumPolicy
     */
    public void setChecksumPolicy( String checksumPolicy )
    {
        this.checksumPolicy = checksumPolicy;
    } //-- void setChecksumPolicy( String )

    /**
     * Set if this repo is Proxy, should we download remote
     * indexes?
     * 
     * @param downloadRemoteIndexes
     */
    public void setDownloadRemoteIndexes( boolean downloadRemoteIndexes )
    {
        this.downloadRemoteIndexes = downloadRemoteIndexes;
    } //-- void setDownloadRemoteIndexes( boolean )

    /**
     * Set repository ID. It should uniquely identify this
     * repository across Nexus.
     * 
     * @param id
     */
    public void setId( String id )
    {
        this.id = id;
    } //-- void setId( String )

    /**
     * Set if true, repository will get indexed. If false, the
     * files and artifacts from repository will NOT
     *             appear on Nexus
     *             index, thus will be not searcheable (and
     * browseable on views that relies on
     *             index), altough it will
     *             serve Maven clients properly.
     * 
     * @param indexable
     */
    public void setIndexable( boolean indexable )
    {
        this.indexable = indexable;
    } //-- void setIndexable( boolean )

    /**
     * Set the local status of repository.
     * 
     * @param localStatus
     */
    public void setLocalStatus( String localStatus )
    {
        this.localStatus = localStatus;
    } //-- void setLocalStatus( String )

    /**
     * Set the local storage definition of repository. It is
     * optional element. If not defined, the
     *             repository will
     *             use the shared
     *             local storage.
     * 
     * @param localStorage
     */
    public void setLocalStorage( CLocalStorage localStorage )
    {
        this.localStorage = localStorage;
    } //-- void setLocalStorage( CLocalStorage )

    /**
     * Set if true, repository will fix/maintain repository
     * metadata (according to it's repositoryType)
     *             that is
     *             coming from it's
     *             remote store (this setting does not affect
     * hosted reposes). Beware,
     *             this setting is modifying the
     *             repo metadata!
     * 
     * @param maintainProxiedRepositoryMetadata
     */
    public void setMaintainProxiedRepositoryMetadata( boolean maintainProxiedRepositoryMetadata )
    {
        this.maintainProxiedRepositoryMetadata = maintainProxiedRepositoryMetadata;
    } //-- void setMaintainProxiedRepositoryMetadata( boolean )

    /**
     * Set max. minutes that have to pass before Nexus will look to
     * remote peer for possibly new version of
     *             repository metadata.
     * 
     * @param metadataMaxAge
     */
    public void setMetadataMaxAge( int metadataMaxAge )
    {
        this.metadataMaxAge = metadataMaxAge;
    } //-- void setMetadataMaxAge( int )

    /**
     * Set human readable Repository name.
     * 
     * @param name
     */
    public void setName( String name )
    {
        this.name = name;
    } //-- void setName( String )

    /**
     * Set notFoundCache, the neg-cache records time to live in
     * minutes. How long will misses be cached.
     * 
     * @param notFoundCacheTTL
     */
    public void setNotFoundCacheTTL( int notFoundCacheTTL )
    {
        this.notFoundCacheTTL = notFoundCacheTTL;
    } //-- void setNotFoundCacheTTL( int )

    /**
     * Set the proxyMode of repository.
     * 
     * @param proxyMode
     */
    public void setProxyMode( String proxyMode )
    {
        this.proxyMode = proxyMode;
    } //-- void setProxyMode( String )

    /**
     * Set the ID of defined realm from "security" section of
     * configuration.
     * 
     * @param realmId
     */
    public void setRealmId( String realmId )
    {
        this.realmId = realmId;
    } //-- void setRealmId( String )

    /**
     * Set the remote storage definition of repository. It not
     * defined, the repository will be
     *             Nexus-hosted. If
     *             defined at least
     *             the remote URL, the repository will be
     * proxy-repository.
     * 
     * @param remoteStorage
     */
    public void setRemoteStorage( CRemoteStorage remoteStorage )
    {
        this.remoteStorage = remoteStorage;
    } //-- void setRemoteStorage( CRemoteStorage )

    /**
     * Set the type of repository, it may have "release" or
     * "snapshot" values allowing it to
     *             host/proxy/server
     *             release or snapshot
     *             artifacts only.
     * 
     * @param repositoryPolicy
     */
    public void setRepositoryPolicy( String repositoryPolicy )
    {
        this.repositoryPolicy = repositoryPolicy;
    } //-- void setRepositoryPolicy( String )

    /**
     * Set the type of repository.
     * 
     * @param type
     */
    public void setType( String type )
    {
        this.type = type;
    } //-- void setType( String )

    
    public static final String REPOSITORY_POLICY_RELEASE = "release";
    public static final String REPOSITORY_POLICY_SNAPSHOT = "snapshot";

    public static final String CHECKSUM_POLICY_IGNORE = "ignore";
    public static final String CHECKSUM_POLICY_WARN = "warn";
    public static final String CHECKSUM_POLICY_STRICT_IF_EXISTS = "strictIfExists";
    public static final String CHECKSUM_POLICY_STRICT = "strict";

    public static final String PROXY_MODE_ALLOW = "allow";
    public static final String PROXY_MODE_BLOCKED_AUTO = "blockedAuto";
    public static final String PROXY_MODE_BLOCKED_MANUAL = "blockedManual";

    public static final String TYPE_MAVEN2 = "maven2";
    public static final String TYPE_MAVEN1 = "maven1";
    public static final String TYPE_MAVEN_SITE = "maven-site";
    public static final String TYPE_ECLIPSE_UPDATE_SITE = "eclipse-update-site";

    /* A field that "carries" the Configuration modelVersion with object */
    public final String modelVersion = Configuration.MODEL_VERSION;
    
    /* A field to store the default local storage URL */
    public transient String defaultLocalStorageUrl;

}
