/*
 * $Id$
 */

package org.sonatype.nexus.configuration.model.v1_10_0.upgrade;

  //---------------------------------/
 //- Imported classes and packages -/
//---------------------------------/

import org.sonatype.nexus.configuration.model.v1_10_0.CErrorReporting;
import org.sonatype.nexus.configuration.model.v1_10_0.CHttpProxySettings;
import org.sonatype.nexus.configuration.model.v1_10_0.CLocalStorage;
import org.sonatype.nexus.configuration.model.v1_10_0.CMirror;
import org.sonatype.nexus.configuration.model.v1_10_0.CNotification;
import org.sonatype.nexus.configuration.model.v1_10_0.CNotificationTarget;
import org.sonatype.nexus.configuration.model.v1_10_0.CPathMappingItem;
import org.sonatype.nexus.configuration.model.v1_10_0.CPlugin;
import org.sonatype.nexus.configuration.model.v1_10_0.CProps;
import org.sonatype.nexus.configuration.model.v1_10_0.CRemoteAuthentication;
import org.sonatype.nexus.configuration.model.v1_10_0.CRemoteConnectionSettings;
import org.sonatype.nexus.configuration.model.v1_10_0.CRemoteHttpProxySettings;
import org.sonatype.nexus.configuration.model.v1_10_0.CRemoteNexusInstance;
import org.sonatype.nexus.configuration.model.v1_10_0.CRemoteStorage;
import org.sonatype.nexus.configuration.model.v1_10_0.CRepository;
import org.sonatype.nexus.configuration.model.v1_10_0.CRepositoryGrouping;
import org.sonatype.nexus.configuration.model.v1_10_0.CRepositoryTarget;
import org.sonatype.nexus.configuration.model.v1_10_0.CRestApiSettings;
import org.sonatype.nexus.configuration.model.v1_10_0.CRouting;
import org.sonatype.nexus.configuration.model.v1_10_0.CScheduleConfig;
import org.sonatype.nexus.configuration.model.v1_10_0.CScheduledTask;
import org.sonatype.nexus.configuration.model.v1_10_0.CSmtpConfiguration;
import org.sonatype.nexus.configuration.model.v1_10_0.Configuration;

/**
 * Converts between version 1.4.6 and version 1.10.0 of the model.
 * 
 * @version $Revision$ $Date$
 */
public interface VersionUpgrade
{

      //-----------/
     //- Methods -/
    //-----------/

    /**
     * 
     * 
     * @param cErrorReporting
     */
    public org.sonatype.nexus.configuration.model.v1_10_0.CErrorReporting upgradeCErrorReporting( org.sonatype.nexus.configuration.model.v1_4_6.CErrorReporting cErrorReporting );
    /**
     * 
     * 
     * @param cHttpProxySettings
     */
    public org.sonatype.nexus.configuration.model.v1_10_0.CHttpProxySettings upgradeCHttpProxySettings( org.sonatype.nexus.configuration.model.v1_4_6.CHttpProxySettings cHttpProxySettings );
    /**
     * 
     * 
     * @param cLocalStorage
     */
    public org.sonatype.nexus.configuration.model.v1_10_0.CLocalStorage upgradeCLocalStorage( org.sonatype.nexus.configuration.model.v1_4_6.CLocalStorage cLocalStorage );
    /**
     * 
     * 
     * @param cMirror
     */
    public org.sonatype.nexus.configuration.model.v1_10_0.CMirror upgradeCMirror( org.sonatype.nexus.configuration.model.v1_4_6.CMirror cMirror );
    /**
     * 
     * 
     * @param cNotification
     */
    public org.sonatype.nexus.configuration.model.v1_10_0.CNotification upgradeCNotification( org.sonatype.nexus.configuration.model.v1_4_6.CNotification cNotification );
    /**
     * 
     * 
     * @param cNotificationTarget
     */
    public org.sonatype.nexus.configuration.model.v1_10_0.CNotificationTarget upgradeCNotificationTarget( org.sonatype.nexus.configuration.model.v1_4_6.CNotificationTarget cNotificationTarget );
    /**
     * 
     * 
     * @param cPathMappingItem
     */
    public org.sonatype.nexus.configuration.model.v1_10_0.CPathMappingItem upgradeCPathMappingItem( org.sonatype.nexus.configuration.model.v1_4_6.CPathMappingItem cPathMappingItem );
    /**
     * 
     * 
     * @param cPlugin
     */
    public org.sonatype.nexus.configuration.model.v1_10_0.CPlugin upgradeCPlugin( org.sonatype.nexus.configuration.model.v1_4_6.CPlugin cPlugin );
    /**
     * 
     * 
     * @param cProps
     */
    public org.sonatype.nexus.configuration.model.v1_10_0.CProps upgradeCProps( org.sonatype.nexus.configuration.model.v1_4_6.CProps cProps );
    /**
     * 
     * 
     * @param cRemoteAuthentication
     */
    public org.sonatype.nexus.configuration.model.v1_10_0.CRemoteAuthentication upgradeCRemoteAuthentication( org.sonatype.nexus.configuration.model.v1_4_6.CRemoteAuthentication cRemoteAuthentication );
    /**
     * 
     * 
     * @param cRemoteConnectionSettings
     */
    public org.sonatype.nexus.configuration.model.v1_10_0.CRemoteConnectionSettings upgradeCRemoteConnectionSettings( org.sonatype.nexus.configuration.model.v1_4_6.CRemoteConnectionSettings cRemoteConnectionSettings );
    /**
     * 
     * 
     * @param cRemoteHttpProxySettings
     */
    public org.sonatype.nexus.configuration.model.v1_10_0.CRemoteHttpProxySettings upgradeCRemoteHttpProxySettings( org.sonatype.nexus.configuration.model.v1_4_6.CRemoteHttpProxySettings cRemoteHttpProxySettings );
    /**
     * 
     * 
     * @param cRemoteNexusInstance
     */
    public org.sonatype.nexus.configuration.model.v1_10_0.CRemoteNexusInstance upgradeCRemoteNexusInstance( org.sonatype.nexus.configuration.model.v1_4_6.CRemoteNexusInstance cRemoteNexusInstance );
    /**
     * 
     * 
     * @param cRemoteStorage
     */
    public org.sonatype.nexus.configuration.model.v1_10_0.CRemoteStorage upgradeCRemoteStorage( org.sonatype.nexus.configuration.model.v1_4_6.CRemoteStorage cRemoteStorage );
    /**
     * 
     * 
     * @param cRepository
     */
    public org.sonatype.nexus.configuration.model.v1_10_0.CRepository upgradeCRepository( org.sonatype.nexus.configuration.model.v1_4_6.CRepository cRepository );
    /**
     * 
     * 
     * @param cRepositoryGrouping
     */
    public org.sonatype.nexus.configuration.model.v1_10_0.CRepositoryGrouping upgradeCRepositoryGrouping( org.sonatype.nexus.configuration.model.v1_4_6.CRepositoryGrouping cRepositoryGrouping );
    /**
     * 
     * 
     * @param cRepositoryTarget
     */
    public org.sonatype.nexus.configuration.model.v1_10_0.CRepositoryTarget upgradeCRepositoryTarget( org.sonatype.nexus.configuration.model.v1_4_6.CRepositoryTarget cRepositoryTarget );
    /**
     * 
     * 
     * @param cRestApiSettings
     */
    public org.sonatype.nexus.configuration.model.v1_10_0.CRestApiSettings upgradeCRestApiSettings( org.sonatype.nexus.configuration.model.v1_4_6.CRestApiSettings cRestApiSettings );
    /**
     * 
     * 
     * @param cRouting
     */
    public org.sonatype.nexus.configuration.model.v1_10_0.CRouting upgradeCRouting( org.sonatype.nexus.configuration.model.v1_4_6.CRouting cRouting );
    /**
     * 
     * 
     * @param cScheduleConfig
     */
    public org.sonatype.nexus.configuration.model.v1_10_0.CScheduleConfig upgradeCScheduleConfig( org.sonatype.nexus.configuration.model.v1_4_6.CScheduleConfig cScheduleConfig );
    /**
     * 
     * 
     * @param cScheduledTask
     */
    public org.sonatype.nexus.configuration.model.v1_10_0.CScheduledTask upgradeCScheduledTask( org.sonatype.nexus.configuration.model.v1_4_6.CScheduledTask cScheduledTask );
    /**
     * 
     * 
     * @param cSmtpConfiguration
     */
    public org.sonatype.nexus.configuration.model.v1_10_0.CSmtpConfiguration upgradeCSmtpConfiguration( org.sonatype.nexus.configuration.model.v1_4_6.CSmtpConfiguration cSmtpConfiguration );
    /**
     * 
     * 
     * @param configuration
     */
    public org.sonatype.nexus.configuration.model.v1_10_0.Configuration upgradeConfiguration( org.sonatype.nexus.configuration.model.v1_4_6.Configuration configuration );
}
