/*
 =================== DO NOT EDIT THIS FILE ====================
 Generated by Modello 1.6 on 2012-12-19 15:37:07,
 any modifications will be overwritten.
 ==============================================================
 */

package org.sonatype.nexus.configuration.model.v1_4_0;

/**
 * 
 *         The remote storage definition. If URL is only defined,
 * the repository will share one shared remote
 *         storage instance. If
 *         any other properties are defined, the repository will
 * own a private repository
 *         store instance.
 *       
 * 
 * @version $Revision$ $Date$
 */
@SuppressWarnings( "all" )
public class CRemoteStorage
    implements java.io.Serializable
{

      //--------------------------/
     //- Class/Member Variables -/
    //--------------------------/

    /**
     * The provider of the remote storage.
     */
    private String provider;

    /**
     * The URL of the remote storage. Mandatory.
     */
    private String url;

    /**
     * 
     *             The remote authentication, if needed to
     * authenticate on remote repository.
     *           
     */
    private CRemoteAuthentication authentication;

    /**
     * 
     *             The specific connection settings to use when
     * connecting to this repository.
     *           
     */
    private CRemoteConnectionSettings connectionSettings;

    /**
     * Should this remote storage inherit the global settings? If
     * true, it will inherit, if false, the proxy defined or none
     * will be used.
     */
    private boolean inheritHttpProxySettings = false;

    /**
     * 
     *             The specific HTTP Proxy settings to use when
     * connecting to this repository.
     *           
     */
    private CRemoteHttpProxySettings httpProxySettings;

    /**
     * Field mirrors.
     */
    private java.util.List<CMirror> mirrors;


      //-----------/
     //- Methods -/
    //-----------/

    /**
     * Method addMirror.
     * 
     * @param cMirror
     */
    public void addMirror( CMirror cMirror )
    {
        getMirrors().add( cMirror );
    } //-- void addMirror( CMirror )

    /**
     * Get the remote authentication, if needed to authenticate on
     * remote repository.
     * 
     * @return CRemoteAuthentication
     */
    public CRemoteAuthentication getAuthentication()
    {
        return this.authentication;
    } //-- CRemoteAuthentication getAuthentication()

    /**
     * Get the specific connection settings to use when connecting
     * to this repository.
     * 
     * @return CRemoteConnectionSettings
     */
    public CRemoteConnectionSettings getConnectionSettings()
    {
        return this.connectionSettings;
    } //-- CRemoteConnectionSettings getConnectionSettings()

    /**
     * Get the specific HTTP Proxy settings to use when connecting
     * to this repository.
     * 
     * @return CRemoteHttpProxySettings
     */
    public CRemoteHttpProxySettings getHttpProxySettings()
    {
        return this.httpProxySettings;
    } //-- CRemoteHttpProxySettings getHttpProxySettings()

    /**
     * Method getMirrors.
     * 
     * @return List
     */
    public java.util.List<CMirror> getMirrors()
    {
        if ( this.mirrors == null )
        {
            this.mirrors = new java.util.ArrayList<CMirror>();
        }

        return this.mirrors;
    } //-- java.util.List<CMirror> getMirrors()

    /**
     * Get the provider of the remote storage.
     * 
     * @return String
     */
    public String getProvider()
    {
        return this.provider;
    } //-- String getProvider()

    /**
     * Get the URL of the remote storage. Mandatory.
     * 
     * @return String
     */
    public String getUrl()
    {
        return this.url;
    } //-- String getUrl()

    /**
     * Get should this remote storage inherit the global settings?
     * If true, it will inherit, if false, the proxy defined or
     * none will be used.
     * 
     * @return boolean
     */
    public boolean isInheritHttpProxySettings()
    {
        return this.inheritHttpProxySettings;
    } //-- boolean isInheritHttpProxySettings()

    /**
     * Method removeMirror.
     * 
     * @param cMirror
     */
    public void removeMirror( CMirror cMirror )
    {
        getMirrors().remove( cMirror );
    } //-- void removeMirror( CMirror )

    /**
     * Set the remote authentication, if needed to authenticate on
     * remote repository.
     * 
     * @param authentication
     */
    public void setAuthentication( CRemoteAuthentication authentication )
    {
        this.authentication = authentication;
    } //-- void setAuthentication( CRemoteAuthentication )

    /**
     * Set the specific connection settings to use when connecting
     * to this repository.
     * 
     * @param connectionSettings
     */
    public void setConnectionSettings( CRemoteConnectionSettings connectionSettings )
    {
        this.connectionSettings = connectionSettings;
    } //-- void setConnectionSettings( CRemoteConnectionSettings )

    /**
     * Set the specific HTTP Proxy settings to use when connecting
     * to this repository.
     * 
     * @param httpProxySettings
     */
    public void setHttpProxySettings( CRemoteHttpProxySettings httpProxySettings )
    {
        this.httpProxySettings = httpProxySettings;
    } //-- void setHttpProxySettings( CRemoteHttpProxySettings )

    /**
     * Set should this remote storage inherit the global settings?
     * If true, it will inherit, if false, the proxy defined or
     * none will be used.
     * 
     * @param inheritHttpProxySettings
     */
    public void setInheritHttpProxySettings( boolean inheritHttpProxySettings )
    {
        this.inheritHttpProxySettings = inheritHttpProxySettings;
    } //-- void setInheritHttpProxySettings( boolean )

    /**
     * Set repository mirrors configuration for upstream (to use
     * for retrieving stuff).
     * 
     * @param mirrors
     */
    public void setMirrors( java.util.List<CMirror> mirrors )
    {
        this.mirrors = mirrors;
    } //-- void setMirrors( java.util.List )

    /**
     * Set the provider of the remote storage.
     * 
     * @param provider
     */
    public void setProvider( String provider )
    {
        this.provider = provider;
    } //-- void setProvider( String )

    /**
     * Set the URL of the remote storage. Mandatory.
     * 
     * @param url
     */
    public void setUrl( String url )
    {
        this.url = url;
    } //-- void setUrl( String )

}
