/*
 =================== DO NOT EDIT THIS FILE ====================
 Generated by Modello 1.6 on 2012-12-19 15:37:07,
 any modifications will be overwritten.
 ==============================================================
 */

package org.sonatype.nexus.configuration.model.v1_4_0;

/**
 * The Nexus repository model.
 * 
 * @version $Revision$ $Date$
 */
@SuppressWarnings( "all" )
public class CRepository
    implements java.io.Serializable
{

      //--------------------------/
     //- Class/Member Variables -/
    //--------------------------/

    /**
     * Repository ID. It should uniquely identify this repository
     * across Nexus.
     */
    private String id;

    /**
     * Human readable Repository name.
     */
    private String name;

    /**
     * The type of repository.
     */
    private String providerRole;

    /**
     * The implementation of repository.
     */
    private String providerHint;

    /**
     * Path prefix, used by router, to form the URL where this
     * repository will be published.
     */
    private String pathPrefix;

    /**
     * The local status of repository.
     */
    private String localStatus;

    /**
     * 
     *             If true, NFC will be used. If false, no miss
     * caching will happen.
     *           
     */
    private boolean notFoundCacheActive = false;

    /**
     * 
     *             NotFoundCache, the neg-cache records time to
     * live in minutes. How long will misses be cached.
     *           
     */
    private int notFoundCacheTTL = 0;

    /**
     * 
     *             If true, repository is user managed, and it is
     * allowed to be edited/dropped by users.
     *           
     */
    private boolean userManaged = false;

    /**
     * 
     *             If true, repository is exposed at content.
     *           
     */
    private boolean exposed = false;

    /**
     * 
     *             If true, repository is browseable on UI/DAV.
     * With any value repository will still properly serve
     *             Maven clients.
     *           
     */
    private boolean browseable = false;

    /**
     * The policy of the repositories write capability, i.e.
     * (ALLOW_WRITE, ALLOW_WRITE_ONCE, READ_ONLY).
     */
    private String writePolicy;

    /**
     * 
     *             If true, repository will get indexed. If false,
     * the files and artifacts from repository will NOT
     *             be indexed (no index will be maintained for this
     * repository).
     *           
     */
    private boolean indexable = false;

    /**
     * 
     *             If true, repository will be searchable. If
     * false, the files and artifacts from repository will NOT
     *             appear on Nexus index, thus will be not
     * searcheable.
     *           
     */
    private boolean searchable = false;

    /**
     * 
     *             The local storage definition of repository.
     *           
     */
    private CLocalStorage localStorage;

    /**
     * 
     *             The remote storage definition of repository.
     *           
     */
    private CRemoteStorage remoteStorage;

    /**
     * Field mirrors.
     */
    private java.util.List<CMirror> mirrors;

    /**
     * Repository implementation's own configuration.
     */
    private Object externalConfiguration;


      //-----------/
     //- Methods -/
    //-----------/

    /**
     * Method addMirror.
     * 
     * @param cMirror
     */
    public void addMirror( CMirror cMirror )
    {
        getMirrors().add( cMirror );
    } //-- void addMirror( CMirror )

    /**
     * Get repository implementation's own configuration.
     * 
     * @return Object
     */
    public Object getExternalConfiguration()
    {
        return this.externalConfiguration;
    } //-- Object getExternalConfiguration()

    /**
     * Get repository ID. It should uniquely identify this
     * repository across Nexus.
     * 
     * @return String
     */
    public String getId()
    {
        return this.id;
    } //-- String getId()

    /**
     * Get the local status of repository.
     * 
     * @return String
     */
    public String getLocalStatus()
    {
        return this.localStatus;
    } //-- String getLocalStatus()

    /**
     * Get the local storage definition of repository.
     * 
     * @return CLocalStorage
     */
    public CLocalStorage getLocalStorage()
    {
        return this.localStorage;
    } //-- CLocalStorage getLocalStorage()

    /**
     * Method getMirrors.
     * 
     * @return List
     */
    public java.util.List<CMirror> getMirrors()
    {
        if ( this.mirrors == null )
        {
            this.mirrors = new java.util.ArrayList<CMirror>();
        }

        return this.mirrors;
    } //-- java.util.List<CMirror> getMirrors()

    /**
     * Get human readable Repository name.
     * 
     * @return String
     */
    public String getName()
    {
        return this.name;
    } //-- String getName()

    /**
     * Get notFoundCache, the neg-cache records time to live in
     * minutes. How long will misses be cached.
     * 
     * @return int
     */
    public int getNotFoundCacheTTL()
    {
        return this.notFoundCacheTTL;
    } //-- int getNotFoundCacheTTL()

    /**
     * Get path prefix, used by router, to form the URL where this
     * repository will be published.
     * 
     * @return String
     */
    public String getPathPrefix()
    {
        return this.pathPrefix;
    } //-- String getPathPrefix()

    /**
     * Get the implementation of repository.
     * 
     * @return String
     */
    public String getProviderHint()
    {
        return this.providerHint;
    } //-- String getProviderHint()

    /**
     * Get the type of repository.
     * 
     * @return String
     */
    public String getProviderRole()
    {
        return this.providerRole;
    } //-- String getProviderRole()

    /**
     * Get the remote storage definition of repository.
     * 
     * @return CRemoteStorage
     */
    public CRemoteStorage getRemoteStorage()
    {
        return this.remoteStorage;
    } //-- CRemoteStorage getRemoteStorage()

    /**
     * Get the policy of the repositories write capability, i.e.
     * (ALLOW_WRITE, ALLOW_WRITE_ONCE, READ_ONLY).
     * 
     * @return String
     */
    public String getWritePolicy()
    {
        return this.writePolicy;
    } //-- String getWritePolicy()

    /**
     * Get if true, repository is browseable on UI/DAV. With any
     * value repository will still properly serve
     *             Maven clients.
     * 
     * @return boolean
     */
    public boolean isBrowseable()
    {
        return this.browseable;
    } //-- boolean isBrowseable()

    /**
     * Get if true, repository is exposed at content.
     * 
     * @return boolean
     */
    public boolean isExposed()
    {
        return this.exposed;
    } //-- boolean isExposed()

    /**
     * Get if true, repository will get indexed. If false, the
     * files and artifacts from repository will NOT
     *             be indexed (no index will be maintained for this
     * repository).
     * 
     * @return boolean
     */
    public boolean isIndexable()
    {
        return this.indexable;
    } //-- boolean isIndexable()

    /**
     * Get if true, NFC will be used. If false, no miss caching
     * will happen.
     * 
     * @return boolean
     */
    public boolean isNotFoundCacheActive()
    {
        return this.notFoundCacheActive;
    } //-- boolean isNotFoundCacheActive()

    /**
     * Get if true, repository will be searchable. If false, the
     * files and artifacts from repository will NOT
     *             appear on Nexus index, thus will be not
     * searcheable.
     * 
     * @return boolean
     */
    public boolean isSearchable()
    {
        return this.searchable;
    } //-- boolean isSearchable()

    /**
     * Get if true, repository is user managed, and it is allowed
     * to be edited/dropped by users.
     * 
     * @return boolean
     */
    public boolean isUserManaged()
    {
        return this.userManaged;
    } //-- boolean isUserManaged()

    /**
     * Method removeMirror.
     * 
     * @param cMirror
     */
    public void removeMirror( CMirror cMirror )
    {
        getMirrors().remove( cMirror );
    } //-- void removeMirror( CMirror )

    /**
     * Set if true, repository is browseable on UI/DAV. With any
     * value repository will still properly serve
     *             Maven clients.
     * 
     * @param browseable
     */
    public void setBrowseable( boolean browseable )
    {
        this.browseable = browseable;
    } //-- void setBrowseable( boolean )

    /**
     * Set if true, repository is exposed at content.
     * 
     * @param exposed
     */
    public void setExposed( boolean exposed )
    {
        this.exposed = exposed;
    } //-- void setExposed( boolean )

    /**
     * Set repository implementation's own configuration.
     * 
     * @param externalConfiguration
     */
    public void setExternalConfiguration( Object externalConfiguration )
    {
        this.externalConfiguration = externalConfiguration;
    } //-- void setExternalConfiguration( Object )

    /**
     * Set repository ID. It should uniquely identify this
     * repository across Nexus.
     * 
     * @param id
     */
    public void setId( String id )
    {
        this.id = id;
    } //-- void setId( String )

    /**
     * Set if true, repository will get indexed. If false, the
     * files and artifacts from repository will NOT
     *             be indexed (no index will be maintained for this
     * repository).
     * 
     * @param indexable
     */
    public void setIndexable( boolean indexable )
    {
        this.indexable = indexable;
    } //-- void setIndexable( boolean )

    /**
     * Set the local status of repository.
     * 
     * @param localStatus
     */
    public void setLocalStatus( String localStatus )
    {
        this.localStatus = localStatus;
    } //-- void setLocalStatus( String )

    /**
     * Set the local storage definition of repository.
     * 
     * @param localStorage
     */
    public void setLocalStorage( CLocalStorage localStorage )
    {
        this.localStorage = localStorage;
    } //-- void setLocalStorage( CLocalStorage )

    /**
     * Set repository mirrors to publish downstream.
     * 
     * @param mirrors
     */
    public void setMirrors( java.util.List<CMirror> mirrors )
    {
        this.mirrors = mirrors;
    } //-- void setMirrors( java.util.List )

    /**
     * Set human readable Repository name.
     * 
     * @param name
     */
    public void setName( String name )
    {
        this.name = name;
    } //-- void setName( String )

    /**
     * Set if true, NFC will be used. If false, no miss caching
     * will happen.
     * 
     * @param notFoundCacheActive
     */
    public void setNotFoundCacheActive( boolean notFoundCacheActive )
    {
        this.notFoundCacheActive = notFoundCacheActive;
    } //-- void setNotFoundCacheActive( boolean )

    /**
     * Set notFoundCache, the neg-cache records time to live in
     * minutes. How long will misses be cached.
     * 
     * @param notFoundCacheTTL
     */
    public void setNotFoundCacheTTL( int notFoundCacheTTL )
    {
        this.notFoundCacheTTL = notFoundCacheTTL;
    } //-- void setNotFoundCacheTTL( int )

    /**
     * Set path prefix, used by router, to form the URL where this
     * repository will be published.
     * 
     * @param pathPrefix
     */
    public void setPathPrefix( String pathPrefix )
    {
        this.pathPrefix = pathPrefix;
    } //-- void setPathPrefix( String )

    /**
     * Set the implementation of repository.
     * 
     * @param providerHint
     */
    public void setProviderHint( String providerHint )
    {
        this.providerHint = providerHint;
    } //-- void setProviderHint( String )

    /**
     * Set the type of repository.
     * 
     * @param providerRole
     */
    public void setProviderRole( String providerRole )
    {
        this.providerRole = providerRole;
    } //-- void setProviderRole( String )

    /**
     * Set the remote storage definition of repository.
     * 
     * @param remoteStorage
     */
    public void setRemoteStorage( CRemoteStorage remoteStorage )
    {
        this.remoteStorage = remoteStorage;
    } //-- void setRemoteStorage( CRemoteStorage )

    /**
     * Set if true, repository will be searchable. If false, the
     * files and artifacts from repository will NOT
     *             appear on Nexus index, thus will be not
     * searcheable.
     * 
     * @param searchable
     */
    public void setSearchable( boolean searchable )
    {
        this.searchable = searchable;
    } //-- void setSearchable( boolean )

    /**
     * Set if true, repository is user managed, and it is allowed
     * to be edited/dropped by users.
     * 
     * @param userManaged
     */
    public void setUserManaged( boolean userManaged )
    {
        this.userManaged = userManaged;
    } //-- void setUserManaged( boolean )

    /**
     * Set the policy of the repositories write capability, i.e.
     * (ALLOW_WRITE, ALLOW_WRITE_ONCE, READ_ONLY).
     * 
     * @param writePolicy
     */
    public void setWritePolicy( String writePolicy )
    {
        this.writePolicy = writePolicy;
    } //-- void setWritePolicy( String )

    
    /* A field that "carries" the Configuration modelVersion with object */
    public final String modelVersion = Configuration.MODEL_VERSION;
    
    /* A field to store the default local storage URL */
    public transient String defaultLocalStorageUrl;

    /* A field to store actual external configuration implementation */
    public transient Object externalConfigurationImple;

}
