/*
 * $Id$
 */

package org.sonatype.nexus.configuration.model.v1_4_1.upgrade;

  //---------------------------------/
 //- Imported classes and packages -/
//---------------------------------/

import org.sonatype.nexus.configuration.model.v1_4_1.CErrorReporting;
import org.sonatype.nexus.configuration.model.v1_4_1.CHttpProxySettings;
import org.sonatype.nexus.configuration.model.v1_4_1.CLocalStorage;
import org.sonatype.nexus.configuration.model.v1_4_1.CMirror;
import org.sonatype.nexus.configuration.model.v1_4_1.CPathMappingItem;
import org.sonatype.nexus.configuration.model.v1_4_1.CPlugin;
import org.sonatype.nexus.configuration.model.v1_4_1.CProps;
import org.sonatype.nexus.configuration.model.v1_4_1.CRemoteAuthentication;
import org.sonatype.nexus.configuration.model.v1_4_1.CRemoteConnectionSettings;
import org.sonatype.nexus.configuration.model.v1_4_1.CRemoteHttpProxySettings;
import org.sonatype.nexus.configuration.model.v1_4_1.CRemoteNexusInstance;
import org.sonatype.nexus.configuration.model.v1_4_1.CRemoteStorage;
import org.sonatype.nexus.configuration.model.v1_4_1.CRepository;
import org.sonatype.nexus.configuration.model.v1_4_1.CRepositoryGrouping;
import org.sonatype.nexus.configuration.model.v1_4_1.CRepositoryTarget;
import org.sonatype.nexus.configuration.model.v1_4_1.CRestApiSettings;
import org.sonatype.nexus.configuration.model.v1_4_1.CRouting;
import org.sonatype.nexus.configuration.model.v1_4_1.CScheduleConfig;
import org.sonatype.nexus.configuration.model.v1_4_1.CScheduledTask;
import org.sonatype.nexus.configuration.model.v1_4_1.CSmtpConfiguration;
import org.sonatype.nexus.configuration.model.v1_4_1.Configuration;

/**
 * Converts between version 1.4.0 and version 1.4.1 of the model.
 * 
 * @version $Revision$ $Date$
 */
public interface VersionUpgrade
{

      //-----------/
     //- Methods -/
    //-----------/

    /**
     * 
     * 
     * @param cErrorReporting
     */
    public org.sonatype.nexus.configuration.model.v1_4_1.CErrorReporting upgradeCErrorReporting( org.sonatype.nexus.configuration.model.v1_4_0.CErrorReporting cErrorReporting );
    /**
     * 
     * 
     * @param cHttpProxySettings
     */
    public org.sonatype.nexus.configuration.model.v1_4_1.CHttpProxySettings upgradeCHttpProxySettings( org.sonatype.nexus.configuration.model.v1_4_0.CHttpProxySettings cHttpProxySettings );
    /**
     * 
     * 
     * @param cLocalStorage
     */
    public org.sonatype.nexus.configuration.model.v1_4_1.CLocalStorage upgradeCLocalStorage( org.sonatype.nexus.configuration.model.v1_4_0.CLocalStorage cLocalStorage );
    /**
     * 
     * 
     * @param cMirror
     */
    public org.sonatype.nexus.configuration.model.v1_4_1.CMirror upgradeCMirror( org.sonatype.nexus.configuration.model.v1_4_0.CMirror cMirror );
    /**
     * 
     * 
     * @param cPathMappingItem
     */
    public org.sonatype.nexus.configuration.model.v1_4_1.CPathMappingItem upgradeCPathMappingItem( org.sonatype.nexus.configuration.model.v1_4_0.CPathMappingItem cPathMappingItem );
    /**
     * 
     * 
     * @param cPlugin
     */
    public org.sonatype.nexus.configuration.model.v1_4_1.CPlugin upgradeCPlugin( org.sonatype.nexus.configuration.model.v1_4_0.CPlugin cPlugin );
    /**
     * 
     * 
     * @param cProps
     */
    public org.sonatype.nexus.configuration.model.v1_4_1.CProps upgradeCProps( org.sonatype.nexus.configuration.model.v1_4_0.CProps cProps );
    /**
     * 
     * 
     * @param cRemoteAuthentication
     */
    public org.sonatype.nexus.configuration.model.v1_4_1.CRemoteAuthentication upgradeCRemoteAuthentication( org.sonatype.nexus.configuration.model.v1_4_0.CRemoteAuthentication cRemoteAuthentication );
    /**
     * 
     * 
     * @param cRemoteConnectionSettings
     */
    public org.sonatype.nexus.configuration.model.v1_4_1.CRemoteConnectionSettings upgradeCRemoteConnectionSettings( org.sonatype.nexus.configuration.model.v1_4_0.CRemoteConnectionSettings cRemoteConnectionSettings );
    /**
     * 
     * 
     * @param cRemoteHttpProxySettings
     */
    public org.sonatype.nexus.configuration.model.v1_4_1.CRemoteHttpProxySettings upgradeCRemoteHttpProxySettings( org.sonatype.nexus.configuration.model.v1_4_0.CRemoteHttpProxySettings cRemoteHttpProxySettings );
    /**
     * 
     * 
     * @param cRemoteNexusInstance
     */
    public org.sonatype.nexus.configuration.model.v1_4_1.CRemoteNexusInstance upgradeCRemoteNexusInstance( org.sonatype.nexus.configuration.model.v1_4_0.CRemoteNexusInstance cRemoteNexusInstance );
    /**
     * 
     * 
     * @param cRemoteStorage
     */
    public org.sonatype.nexus.configuration.model.v1_4_1.CRemoteStorage upgradeCRemoteStorage( org.sonatype.nexus.configuration.model.v1_4_0.CRemoteStorage cRemoteStorage );
    /**
     * 
     * 
     * @param cRepository
     */
    public org.sonatype.nexus.configuration.model.v1_4_1.CRepository upgradeCRepository( org.sonatype.nexus.configuration.model.v1_4_0.CRepository cRepository );
    /**
     * 
     * 
     * @param cRepositoryGrouping
     */
    public org.sonatype.nexus.configuration.model.v1_4_1.CRepositoryGrouping upgradeCRepositoryGrouping( org.sonatype.nexus.configuration.model.v1_4_0.CRepositoryGrouping cRepositoryGrouping );
    /**
     * 
     * 
     * @param cRepositoryTarget
     */
    public org.sonatype.nexus.configuration.model.v1_4_1.CRepositoryTarget upgradeCRepositoryTarget( org.sonatype.nexus.configuration.model.v1_4_0.CRepositoryTarget cRepositoryTarget );
    /**
     * 
     * 
     * @param cRestApiSettings
     */
    public org.sonatype.nexus.configuration.model.v1_4_1.CRestApiSettings upgradeCRestApiSettings( org.sonatype.nexus.configuration.model.v1_4_0.CRestApiSettings cRestApiSettings );
    /**
     * 
     * 
     * @param cRouting
     */
    public org.sonatype.nexus.configuration.model.v1_4_1.CRouting upgradeCRouting( org.sonatype.nexus.configuration.model.v1_4_0.CRouting cRouting );
    /**
     * 
     * 
     * @param cScheduleConfig
     */
    public org.sonatype.nexus.configuration.model.v1_4_1.CScheduleConfig upgradeCScheduleConfig( org.sonatype.nexus.configuration.model.v1_4_0.CScheduleConfig cScheduleConfig );
    /**
     * 
     * 
     * @param cScheduledTask
     */
    public org.sonatype.nexus.configuration.model.v1_4_1.CScheduledTask upgradeCScheduledTask( org.sonatype.nexus.configuration.model.v1_4_0.CScheduledTask cScheduledTask );
    /**
     * 
     * 
     * @param cSmtpConfiguration
     */
    public org.sonatype.nexus.configuration.model.v1_4_1.CSmtpConfiguration upgradeCSmtpConfiguration( org.sonatype.nexus.configuration.model.v1_4_0.CSmtpConfiguration cSmtpConfiguration );
    /**
     * 
     * 
     * @param configuration
     */
    public org.sonatype.nexus.configuration.model.v1_4_1.Configuration upgradeConfiguration( org.sonatype.nexus.configuration.model.v1_4_0.Configuration configuration );
}
