/*
 * $Id$
 */

package org.sonatype.nexus.configuration.model.v1_4_2.upgrade;

  //---------------------------------/
 //- Imported classes and packages -/
//---------------------------------/

import org.sonatype.nexus.configuration.model.v1_4_2.CErrorReporting;
import org.sonatype.nexus.configuration.model.v1_4_2.CHttpProxySettings;
import org.sonatype.nexus.configuration.model.v1_4_2.CLocalStorage;
import org.sonatype.nexus.configuration.model.v1_4_2.CMirror;
import org.sonatype.nexus.configuration.model.v1_4_2.CNotification;
import org.sonatype.nexus.configuration.model.v1_4_2.CNotificationTarget;
import org.sonatype.nexus.configuration.model.v1_4_2.CPathMappingItem;
import org.sonatype.nexus.configuration.model.v1_4_2.CPlugin;
import org.sonatype.nexus.configuration.model.v1_4_2.CProps;
import org.sonatype.nexus.configuration.model.v1_4_2.CRemoteAuthentication;
import org.sonatype.nexus.configuration.model.v1_4_2.CRemoteConnectionSettings;
import org.sonatype.nexus.configuration.model.v1_4_2.CRemoteHttpProxySettings;
import org.sonatype.nexus.configuration.model.v1_4_2.CRemoteNexusInstance;
import org.sonatype.nexus.configuration.model.v1_4_2.CRemoteStorage;
import org.sonatype.nexus.configuration.model.v1_4_2.CRepository;
import org.sonatype.nexus.configuration.model.v1_4_2.CRepositoryGrouping;
import org.sonatype.nexus.configuration.model.v1_4_2.CRepositoryTarget;
import org.sonatype.nexus.configuration.model.v1_4_2.CRestApiSettings;
import org.sonatype.nexus.configuration.model.v1_4_2.CRouting;
import org.sonatype.nexus.configuration.model.v1_4_2.CScheduleConfig;
import org.sonatype.nexus.configuration.model.v1_4_2.CScheduledTask;
import org.sonatype.nexus.configuration.model.v1_4_2.CSmtpConfiguration;
import org.sonatype.nexus.configuration.model.v1_4_2.Configuration;

/**
 * Converts between version 1.4.1 and version 1.4.2 of the model.
 * 
 * @version $Revision$ $Date$
 */
public interface VersionUpgrade
{

      //-----------/
     //- Methods -/
    //-----------/

    /**
     * 
     * 
     * @param cErrorReporting
     */
    public org.sonatype.nexus.configuration.model.v1_4_2.CErrorReporting upgradeCErrorReporting( org.sonatype.nexus.configuration.model.v1_4_1.CErrorReporting cErrorReporting );
    /**
     * 
     * 
     * @param cHttpProxySettings
     */
    public org.sonatype.nexus.configuration.model.v1_4_2.CHttpProxySettings upgradeCHttpProxySettings( org.sonatype.nexus.configuration.model.v1_4_1.CHttpProxySettings cHttpProxySettings );
    /**
     * 
     * 
     * @param cLocalStorage
     */
    public org.sonatype.nexus.configuration.model.v1_4_2.CLocalStorage upgradeCLocalStorage( org.sonatype.nexus.configuration.model.v1_4_1.CLocalStorage cLocalStorage );
    /**
     * 
     * 
     * @param cMirror
     */
    public org.sonatype.nexus.configuration.model.v1_4_2.CMirror upgradeCMirror( org.sonatype.nexus.configuration.model.v1_4_1.CMirror cMirror );
    /**
     * 
     * 
     * @param cNotification
     */
    public org.sonatype.nexus.configuration.model.v1_4_2.CNotification upgradeCNotification( org.sonatype.nexus.configuration.model.v1_4_1.CNotification cNotification );
    /**
     * 
     * 
     * @param cNotificationTarget
     */
    public org.sonatype.nexus.configuration.model.v1_4_2.CNotificationTarget upgradeCNotificationTarget( org.sonatype.nexus.configuration.model.v1_4_1.CNotificationTarget cNotificationTarget );
    /**
     * 
     * 
     * @param cPathMappingItem
     */
    public org.sonatype.nexus.configuration.model.v1_4_2.CPathMappingItem upgradeCPathMappingItem( org.sonatype.nexus.configuration.model.v1_4_1.CPathMappingItem cPathMappingItem );
    /**
     * 
     * 
     * @param cPlugin
     */
    public org.sonatype.nexus.configuration.model.v1_4_2.CPlugin upgradeCPlugin( org.sonatype.nexus.configuration.model.v1_4_1.CPlugin cPlugin );
    /**
     * 
     * 
     * @param cProps
     */
    public org.sonatype.nexus.configuration.model.v1_4_2.CProps upgradeCProps( org.sonatype.nexus.configuration.model.v1_4_1.CProps cProps );
    /**
     * 
     * 
     * @param cRemoteAuthentication
     */
    public org.sonatype.nexus.configuration.model.v1_4_2.CRemoteAuthentication upgradeCRemoteAuthentication( org.sonatype.nexus.configuration.model.v1_4_1.CRemoteAuthentication cRemoteAuthentication );
    /**
     * 
     * 
     * @param cRemoteConnectionSettings
     */
    public org.sonatype.nexus.configuration.model.v1_4_2.CRemoteConnectionSettings upgradeCRemoteConnectionSettings( org.sonatype.nexus.configuration.model.v1_4_1.CRemoteConnectionSettings cRemoteConnectionSettings );
    /**
     * 
     * 
     * @param cRemoteHttpProxySettings
     */
    public org.sonatype.nexus.configuration.model.v1_4_2.CRemoteHttpProxySettings upgradeCRemoteHttpProxySettings( org.sonatype.nexus.configuration.model.v1_4_1.CRemoteHttpProxySettings cRemoteHttpProxySettings );
    /**
     * 
     * 
     * @param cRemoteNexusInstance
     */
    public org.sonatype.nexus.configuration.model.v1_4_2.CRemoteNexusInstance upgradeCRemoteNexusInstance( org.sonatype.nexus.configuration.model.v1_4_1.CRemoteNexusInstance cRemoteNexusInstance );
    /**
     * 
     * 
     * @param cRemoteStorage
     */
    public org.sonatype.nexus.configuration.model.v1_4_2.CRemoteStorage upgradeCRemoteStorage( org.sonatype.nexus.configuration.model.v1_4_1.CRemoteStorage cRemoteStorage );
    /**
     * 
     * 
     * @param cRepository
     */
    public org.sonatype.nexus.configuration.model.v1_4_2.CRepository upgradeCRepository( org.sonatype.nexus.configuration.model.v1_4_1.CRepository cRepository );
    /**
     * 
     * 
     * @param cRepositoryGrouping
     */
    public org.sonatype.nexus.configuration.model.v1_4_2.CRepositoryGrouping upgradeCRepositoryGrouping( org.sonatype.nexus.configuration.model.v1_4_1.CRepositoryGrouping cRepositoryGrouping );
    /**
     * 
     * 
     * @param cRepositoryTarget
     */
    public org.sonatype.nexus.configuration.model.v1_4_2.CRepositoryTarget upgradeCRepositoryTarget( org.sonatype.nexus.configuration.model.v1_4_1.CRepositoryTarget cRepositoryTarget );
    /**
     * 
     * 
     * @param cRestApiSettings
     */
    public org.sonatype.nexus.configuration.model.v1_4_2.CRestApiSettings upgradeCRestApiSettings( org.sonatype.nexus.configuration.model.v1_4_1.CRestApiSettings cRestApiSettings );
    /**
     * 
     * 
     * @param cRouting
     */
    public org.sonatype.nexus.configuration.model.v1_4_2.CRouting upgradeCRouting( org.sonatype.nexus.configuration.model.v1_4_1.CRouting cRouting );
    /**
     * 
     * 
     * @param cScheduleConfig
     */
    public org.sonatype.nexus.configuration.model.v1_4_2.CScheduleConfig upgradeCScheduleConfig( org.sonatype.nexus.configuration.model.v1_4_1.CScheduleConfig cScheduleConfig );
    /**
     * 
     * 
     * @param cScheduledTask
     */
    public org.sonatype.nexus.configuration.model.v1_4_2.CScheduledTask upgradeCScheduledTask( org.sonatype.nexus.configuration.model.v1_4_1.CScheduledTask cScheduledTask );
    /**
     * 
     * 
     * @param cSmtpConfiguration
     */
    public org.sonatype.nexus.configuration.model.v1_4_2.CSmtpConfiguration upgradeCSmtpConfiguration( org.sonatype.nexus.configuration.model.v1_4_1.CSmtpConfiguration cSmtpConfiguration );
    /**
     * 
     * 
     * @param configuration
     */
    public org.sonatype.nexus.configuration.model.v1_4_2.Configuration upgradeConfiguration( org.sonatype.nexus.configuration.model.v1_4_1.Configuration configuration );
}
