/*
 * $Id$
 */

package org.sonatype.nexus.configuration.model.v1_4_3.upgrade;

  //---------------------------------/
 //- Imported classes and packages -/
//---------------------------------/

import org.sonatype.nexus.configuration.model.v1_4_3.CErrorReporting;
import org.sonatype.nexus.configuration.model.v1_4_3.CHttpProxySettings;
import org.sonatype.nexus.configuration.model.v1_4_3.CLocalStorage;
import org.sonatype.nexus.configuration.model.v1_4_3.CMirror;
import org.sonatype.nexus.configuration.model.v1_4_3.CNotification;
import org.sonatype.nexus.configuration.model.v1_4_3.CNotificationTarget;
import org.sonatype.nexus.configuration.model.v1_4_3.CPathMappingItem;
import org.sonatype.nexus.configuration.model.v1_4_3.CPlugin;
import org.sonatype.nexus.configuration.model.v1_4_3.CProps;
import org.sonatype.nexus.configuration.model.v1_4_3.CRemoteAuthentication;
import org.sonatype.nexus.configuration.model.v1_4_3.CRemoteConnectionSettings;
import org.sonatype.nexus.configuration.model.v1_4_3.CRemoteHttpProxySettings;
import org.sonatype.nexus.configuration.model.v1_4_3.CRemoteNexusInstance;
import org.sonatype.nexus.configuration.model.v1_4_3.CRemoteStorage;
import org.sonatype.nexus.configuration.model.v1_4_3.CRepository;
import org.sonatype.nexus.configuration.model.v1_4_3.CRepositoryGrouping;
import org.sonatype.nexus.configuration.model.v1_4_3.CRepositoryTarget;
import org.sonatype.nexus.configuration.model.v1_4_3.CRestApiSettings;
import org.sonatype.nexus.configuration.model.v1_4_3.CRouting;
import org.sonatype.nexus.configuration.model.v1_4_3.CScheduleConfig;
import org.sonatype.nexus.configuration.model.v1_4_3.CScheduledTask;
import org.sonatype.nexus.configuration.model.v1_4_3.CSmtpConfiguration;
import org.sonatype.nexus.configuration.model.v1_4_3.Configuration;

/**
 * Converts between version 1.4.2 and version 1.4.3 of the model.
 * 
 * @version $Revision$ $Date$
 */
public interface VersionUpgrade
{

      //-----------/
     //- Methods -/
    //-----------/

    /**
     * 
     * 
     * @param cErrorReporting
     */
    public org.sonatype.nexus.configuration.model.v1_4_3.CErrorReporting upgradeCErrorReporting( org.sonatype.nexus.configuration.model.v1_4_2.CErrorReporting cErrorReporting );
    /**
     * 
     * 
     * @param cHttpProxySettings
     */
    public org.sonatype.nexus.configuration.model.v1_4_3.CHttpProxySettings upgradeCHttpProxySettings( org.sonatype.nexus.configuration.model.v1_4_2.CHttpProxySettings cHttpProxySettings );
    /**
     * 
     * 
     * @param cLocalStorage
     */
    public org.sonatype.nexus.configuration.model.v1_4_3.CLocalStorage upgradeCLocalStorage( org.sonatype.nexus.configuration.model.v1_4_2.CLocalStorage cLocalStorage );
    /**
     * 
     * 
     * @param cMirror
     */
    public org.sonatype.nexus.configuration.model.v1_4_3.CMirror upgradeCMirror( org.sonatype.nexus.configuration.model.v1_4_2.CMirror cMirror );
    /**
     * 
     * 
     * @param cNotification
     */
    public org.sonatype.nexus.configuration.model.v1_4_3.CNotification upgradeCNotification( org.sonatype.nexus.configuration.model.v1_4_2.CNotification cNotification );
    /**
     * 
     * 
     * @param cNotificationTarget
     */
    public org.sonatype.nexus.configuration.model.v1_4_3.CNotificationTarget upgradeCNotificationTarget( org.sonatype.nexus.configuration.model.v1_4_2.CNotificationTarget cNotificationTarget );
    /**
     * 
     * 
     * @param cPathMappingItem
     */
    public org.sonatype.nexus.configuration.model.v1_4_3.CPathMappingItem upgradeCPathMappingItem( org.sonatype.nexus.configuration.model.v1_4_2.CPathMappingItem cPathMappingItem );
    /**
     * 
     * 
     * @param cPlugin
     */
    public org.sonatype.nexus.configuration.model.v1_4_3.CPlugin upgradeCPlugin( org.sonatype.nexus.configuration.model.v1_4_2.CPlugin cPlugin );
    /**
     * 
     * 
     * @param cProps
     */
    public org.sonatype.nexus.configuration.model.v1_4_3.CProps upgradeCProps( org.sonatype.nexus.configuration.model.v1_4_2.CProps cProps );
    /**
     * 
     * 
     * @param cRemoteAuthentication
     */
    public org.sonatype.nexus.configuration.model.v1_4_3.CRemoteAuthentication upgradeCRemoteAuthentication( org.sonatype.nexus.configuration.model.v1_4_2.CRemoteAuthentication cRemoteAuthentication );
    /**
     * 
     * 
     * @param cRemoteConnectionSettings
     */
    public org.sonatype.nexus.configuration.model.v1_4_3.CRemoteConnectionSettings upgradeCRemoteConnectionSettings( org.sonatype.nexus.configuration.model.v1_4_2.CRemoteConnectionSettings cRemoteConnectionSettings );
    /**
     * 
     * 
     * @param cRemoteHttpProxySettings
     */
    public org.sonatype.nexus.configuration.model.v1_4_3.CRemoteHttpProxySettings upgradeCRemoteHttpProxySettings( org.sonatype.nexus.configuration.model.v1_4_2.CRemoteHttpProxySettings cRemoteHttpProxySettings );
    /**
     * 
     * 
     * @param cRemoteNexusInstance
     */
    public org.sonatype.nexus.configuration.model.v1_4_3.CRemoteNexusInstance upgradeCRemoteNexusInstance( org.sonatype.nexus.configuration.model.v1_4_2.CRemoteNexusInstance cRemoteNexusInstance );
    /**
     * 
     * 
     * @param cRemoteStorage
     */
    public org.sonatype.nexus.configuration.model.v1_4_3.CRemoteStorage upgradeCRemoteStorage( org.sonatype.nexus.configuration.model.v1_4_2.CRemoteStorage cRemoteStorage );
    /**
     * 
     * 
     * @param cRepository
     */
    public org.sonatype.nexus.configuration.model.v1_4_3.CRepository upgradeCRepository( org.sonatype.nexus.configuration.model.v1_4_2.CRepository cRepository );
    /**
     * 
     * 
     * @param cRepositoryGrouping
     */
    public org.sonatype.nexus.configuration.model.v1_4_3.CRepositoryGrouping upgradeCRepositoryGrouping( org.sonatype.nexus.configuration.model.v1_4_2.CRepositoryGrouping cRepositoryGrouping );
    /**
     * 
     * 
     * @param cRepositoryTarget
     */
    public org.sonatype.nexus.configuration.model.v1_4_3.CRepositoryTarget upgradeCRepositoryTarget( org.sonatype.nexus.configuration.model.v1_4_2.CRepositoryTarget cRepositoryTarget );
    /**
     * 
     * 
     * @param cRestApiSettings
     */
    public org.sonatype.nexus.configuration.model.v1_4_3.CRestApiSettings upgradeCRestApiSettings( org.sonatype.nexus.configuration.model.v1_4_2.CRestApiSettings cRestApiSettings );
    /**
     * 
     * 
     * @param cRouting
     */
    public org.sonatype.nexus.configuration.model.v1_4_3.CRouting upgradeCRouting( org.sonatype.nexus.configuration.model.v1_4_2.CRouting cRouting );
    /**
     * 
     * 
     * @param cScheduleConfig
     */
    public org.sonatype.nexus.configuration.model.v1_4_3.CScheduleConfig upgradeCScheduleConfig( org.sonatype.nexus.configuration.model.v1_4_2.CScheduleConfig cScheduleConfig );
    /**
     * 
     * 
     * @param cScheduledTask
     */
    public org.sonatype.nexus.configuration.model.v1_4_3.CScheduledTask upgradeCScheduledTask( org.sonatype.nexus.configuration.model.v1_4_2.CScheduledTask cScheduledTask );
    /**
     * 
     * 
     * @param cSmtpConfiguration
     */
    public org.sonatype.nexus.configuration.model.v1_4_3.CSmtpConfiguration upgradeCSmtpConfiguration( org.sonatype.nexus.configuration.model.v1_4_2.CSmtpConfiguration cSmtpConfiguration );
    /**
     * 
     * 
     * @param configuration
     */
    public org.sonatype.nexus.configuration.model.v1_4_3.Configuration upgradeConfiguration( org.sonatype.nexus.configuration.model.v1_4_2.Configuration configuration );
}
