/*
 * $Id$
 */

package org.sonatype.nexus.configuration.model.v1_4_4.upgrade;

  //---------------------------------/
 //- Imported classes and packages -/
//---------------------------------/

import org.sonatype.nexus.configuration.model.v1_4_4.CErrorReporting;
import org.sonatype.nexus.configuration.model.v1_4_4.CHttpProxySettings;
import org.sonatype.nexus.configuration.model.v1_4_4.CLocalStorage;
import org.sonatype.nexus.configuration.model.v1_4_4.CMirror;
import org.sonatype.nexus.configuration.model.v1_4_4.CNotification;
import org.sonatype.nexus.configuration.model.v1_4_4.CNotificationTarget;
import org.sonatype.nexus.configuration.model.v1_4_4.CPathMappingItem;
import org.sonatype.nexus.configuration.model.v1_4_4.CPlugin;
import org.sonatype.nexus.configuration.model.v1_4_4.CProps;
import org.sonatype.nexus.configuration.model.v1_4_4.CRemoteAuthentication;
import org.sonatype.nexus.configuration.model.v1_4_4.CRemoteConnectionSettings;
import org.sonatype.nexus.configuration.model.v1_4_4.CRemoteHttpProxySettings;
import org.sonatype.nexus.configuration.model.v1_4_4.CRemoteNexusInstance;
import org.sonatype.nexus.configuration.model.v1_4_4.CRemoteStorage;
import org.sonatype.nexus.configuration.model.v1_4_4.CRepository;
import org.sonatype.nexus.configuration.model.v1_4_4.CRepositoryGrouping;
import org.sonatype.nexus.configuration.model.v1_4_4.CRepositoryTarget;
import org.sonatype.nexus.configuration.model.v1_4_4.CRestApiSettings;
import org.sonatype.nexus.configuration.model.v1_4_4.CRouting;
import org.sonatype.nexus.configuration.model.v1_4_4.CScheduleConfig;
import org.sonatype.nexus.configuration.model.v1_4_4.CScheduledTask;
import org.sonatype.nexus.configuration.model.v1_4_4.CSmtpConfiguration;
import org.sonatype.nexus.configuration.model.v1_4_4.Configuration;

/**
 * Converts between version 1.4.3 and version 1.4.4 of the model.
 * 
 * @version $Revision$ $Date$
 */
public interface VersionUpgrade
{

      //-----------/
     //- Methods -/
    //-----------/

    /**
     * 
     * 
     * @param cErrorReporting
     */
    public org.sonatype.nexus.configuration.model.v1_4_4.CErrorReporting upgradeCErrorReporting( org.sonatype.nexus.configuration.model.v1_4_3.CErrorReporting cErrorReporting );
    /**
     * 
     * 
     * @param cHttpProxySettings
     */
    public org.sonatype.nexus.configuration.model.v1_4_4.CHttpProxySettings upgradeCHttpProxySettings( org.sonatype.nexus.configuration.model.v1_4_3.CHttpProxySettings cHttpProxySettings );
    /**
     * 
     * 
     * @param cLocalStorage
     */
    public org.sonatype.nexus.configuration.model.v1_4_4.CLocalStorage upgradeCLocalStorage( org.sonatype.nexus.configuration.model.v1_4_3.CLocalStorage cLocalStorage );
    /**
     * 
     * 
     * @param cMirror
     */
    public org.sonatype.nexus.configuration.model.v1_4_4.CMirror upgradeCMirror( org.sonatype.nexus.configuration.model.v1_4_3.CMirror cMirror );
    /**
     * 
     * 
     * @param cNotification
     */
    public org.sonatype.nexus.configuration.model.v1_4_4.CNotification upgradeCNotification( org.sonatype.nexus.configuration.model.v1_4_3.CNotification cNotification );
    /**
     * 
     * 
     * @param cNotificationTarget
     */
    public org.sonatype.nexus.configuration.model.v1_4_4.CNotificationTarget upgradeCNotificationTarget( org.sonatype.nexus.configuration.model.v1_4_3.CNotificationTarget cNotificationTarget );
    /**
     * 
     * 
     * @param cPathMappingItem
     */
    public org.sonatype.nexus.configuration.model.v1_4_4.CPathMappingItem upgradeCPathMappingItem( org.sonatype.nexus.configuration.model.v1_4_3.CPathMappingItem cPathMappingItem );
    /**
     * 
     * 
     * @param cPlugin
     */
    public org.sonatype.nexus.configuration.model.v1_4_4.CPlugin upgradeCPlugin( org.sonatype.nexus.configuration.model.v1_4_3.CPlugin cPlugin );
    /**
     * 
     * 
     * @param cProps
     */
    public org.sonatype.nexus.configuration.model.v1_4_4.CProps upgradeCProps( org.sonatype.nexus.configuration.model.v1_4_3.CProps cProps );
    /**
     * 
     * 
     * @param cRemoteAuthentication
     */
    public org.sonatype.nexus.configuration.model.v1_4_4.CRemoteAuthentication upgradeCRemoteAuthentication( org.sonatype.nexus.configuration.model.v1_4_3.CRemoteAuthentication cRemoteAuthentication );
    /**
     * 
     * 
     * @param cRemoteConnectionSettings
     */
    public org.sonatype.nexus.configuration.model.v1_4_4.CRemoteConnectionSettings upgradeCRemoteConnectionSettings( org.sonatype.nexus.configuration.model.v1_4_3.CRemoteConnectionSettings cRemoteConnectionSettings );
    /**
     * 
     * 
     * @param cRemoteHttpProxySettings
     */
    public org.sonatype.nexus.configuration.model.v1_4_4.CRemoteHttpProxySettings upgradeCRemoteHttpProxySettings( org.sonatype.nexus.configuration.model.v1_4_3.CRemoteHttpProxySettings cRemoteHttpProxySettings );
    /**
     * 
     * 
     * @param cRemoteNexusInstance
     */
    public org.sonatype.nexus.configuration.model.v1_4_4.CRemoteNexusInstance upgradeCRemoteNexusInstance( org.sonatype.nexus.configuration.model.v1_4_3.CRemoteNexusInstance cRemoteNexusInstance );
    /**
     * 
     * 
     * @param cRemoteStorage
     */
    public org.sonatype.nexus.configuration.model.v1_4_4.CRemoteStorage upgradeCRemoteStorage( org.sonatype.nexus.configuration.model.v1_4_3.CRemoteStorage cRemoteStorage );
    /**
     * 
     * 
     * @param cRepository
     */
    public org.sonatype.nexus.configuration.model.v1_4_4.CRepository upgradeCRepository( org.sonatype.nexus.configuration.model.v1_4_3.CRepository cRepository );
    /**
     * 
     * 
     * @param cRepositoryGrouping
     */
    public org.sonatype.nexus.configuration.model.v1_4_4.CRepositoryGrouping upgradeCRepositoryGrouping( org.sonatype.nexus.configuration.model.v1_4_3.CRepositoryGrouping cRepositoryGrouping );
    /**
     * 
     * 
     * @param cRepositoryTarget
     */
    public org.sonatype.nexus.configuration.model.v1_4_4.CRepositoryTarget upgradeCRepositoryTarget( org.sonatype.nexus.configuration.model.v1_4_3.CRepositoryTarget cRepositoryTarget );
    /**
     * 
     * 
     * @param cRestApiSettings
     */
    public org.sonatype.nexus.configuration.model.v1_4_4.CRestApiSettings upgradeCRestApiSettings( org.sonatype.nexus.configuration.model.v1_4_3.CRestApiSettings cRestApiSettings );
    /**
     * 
     * 
     * @param cRouting
     */
    public org.sonatype.nexus.configuration.model.v1_4_4.CRouting upgradeCRouting( org.sonatype.nexus.configuration.model.v1_4_3.CRouting cRouting );
    /**
     * 
     * 
     * @param cScheduleConfig
     */
    public org.sonatype.nexus.configuration.model.v1_4_4.CScheduleConfig upgradeCScheduleConfig( org.sonatype.nexus.configuration.model.v1_4_3.CScheduleConfig cScheduleConfig );
    /**
     * 
     * 
     * @param cScheduledTask
     */
    public org.sonatype.nexus.configuration.model.v1_4_4.CScheduledTask upgradeCScheduledTask( org.sonatype.nexus.configuration.model.v1_4_3.CScheduledTask cScheduledTask );
    /**
     * 
     * 
     * @param cSmtpConfiguration
     */
    public org.sonatype.nexus.configuration.model.v1_4_4.CSmtpConfiguration upgradeCSmtpConfiguration( org.sonatype.nexus.configuration.model.v1_4_3.CSmtpConfiguration cSmtpConfiguration );
    /**
     * 
     * 
     * @param configuration
     */
    public org.sonatype.nexus.configuration.model.v1_4_4.Configuration upgradeConfiguration( org.sonatype.nexus.configuration.model.v1_4_3.Configuration configuration );
}
