/*
 * $Id$
 */

package org.sonatype.nexus.configuration.model.v1_4_5.upgrade;

  //---------------------------------/
 //- Imported classes and packages -/
//---------------------------------/

import org.sonatype.nexus.configuration.model.v1_4_5.CErrorReporting;
import org.sonatype.nexus.configuration.model.v1_4_5.CHttpProxySettings;
import org.sonatype.nexus.configuration.model.v1_4_5.CLocalStorage;
import org.sonatype.nexus.configuration.model.v1_4_5.CMirror;
import org.sonatype.nexus.configuration.model.v1_4_5.CNotification;
import org.sonatype.nexus.configuration.model.v1_4_5.CNotificationTarget;
import org.sonatype.nexus.configuration.model.v1_4_5.CPathMappingItem;
import org.sonatype.nexus.configuration.model.v1_4_5.CPlugin;
import org.sonatype.nexus.configuration.model.v1_4_5.CProps;
import org.sonatype.nexus.configuration.model.v1_4_5.CRemoteAuthentication;
import org.sonatype.nexus.configuration.model.v1_4_5.CRemoteConnectionSettings;
import org.sonatype.nexus.configuration.model.v1_4_5.CRemoteHttpProxySettings;
import org.sonatype.nexus.configuration.model.v1_4_5.CRemoteNexusInstance;
import org.sonatype.nexus.configuration.model.v1_4_5.CRemoteStorage;
import org.sonatype.nexus.configuration.model.v1_4_5.CRepository;
import org.sonatype.nexus.configuration.model.v1_4_5.CRepositoryGrouping;
import org.sonatype.nexus.configuration.model.v1_4_5.CRepositoryTarget;
import org.sonatype.nexus.configuration.model.v1_4_5.CRestApiSettings;
import org.sonatype.nexus.configuration.model.v1_4_5.CRouting;
import org.sonatype.nexus.configuration.model.v1_4_5.CScheduleConfig;
import org.sonatype.nexus.configuration.model.v1_4_5.CScheduledTask;
import org.sonatype.nexus.configuration.model.v1_4_5.CSmtpConfiguration;
import org.sonatype.nexus.configuration.model.v1_4_5.Configuration;

/**
 * Converts between version 1.4.4 and version 1.4.5 of the model.
 * 
 * @version $Revision$ $Date$
 */
public interface VersionUpgrade
{

      //-----------/
     //- Methods -/
    //-----------/

    /**
     * 
     * 
     * @param cErrorReporting
     */
    public org.sonatype.nexus.configuration.model.v1_4_5.CErrorReporting upgradeCErrorReporting( org.sonatype.nexus.configuration.model.v1_4_4.CErrorReporting cErrorReporting );
    /**
     * 
     * 
     * @param cHttpProxySettings
     */
    public org.sonatype.nexus.configuration.model.v1_4_5.CHttpProxySettings upgradeCHttpProxySettings( org.sonatype.nexus.configuration.model.v1_4_4.CHttpProxySettings cHttpProxySettings );
    /**
     * 
     * 
     * @param cLocalStorage
     */
    public org.sonatype.nexus.configuration.model.v1_4_5.CLocalStorage upgradeCLocalStorage( org.sonatype.nexus.configuration.model.v1_4_4.CLocalStorage cLocalStorage );
    /**
     * 
     * 
     * @param cMirror
     */
    public org.sonatype.nexus.configuration.model.v1_4_5.CMirror upgradeCMirror( org.sonatype.nexus.configuration.model.v1_4_4.CMirror cMirror );
    /**
     * 
     * 
     * @param cNotification
     */
    public org.sonatype.nexus.configuration.model.v1_4_5.CNotification upgradeCNotification( org.sonatype.nexus.configuration.model.v1_4_4.CNotification cNotification );
    /**
     * 
     * 
     * @param cNotificationTarget
     */
    public org.sonatype.nexus.configuration.model.v1_4_5.CNotificationTarget upgradeCNotificationTarget( org.sonatype.nexus.configuration.model.v1_4_4.CNotificationTarget cNotificationTarget );
    /**
     * 
     * 
     * @param cPathMappingItem
     */
    public org.sonatype.nexus.configuration.model.v1_4_5.CPathMappingItem upgradeCPathMappingItem( org.sonatype.nexus.configuration.model.v1_4_4.CPathMappingItem cPathMappingItem );
    /**
     * 
     * 
     * @param cPlugin
     */
    public org.sonatype.nexus.configuration.model.v1_4_5.CPlugin upgradeCPlugin( org.sonatype.nexus.configuration.model.v1_4_4.CPlugin cPlugin );
    /**
     * 
     * 
     * @param cProps
     */
    public org.sonatype.nexus.configuration.model.v1_4_5.CProps upgradeCProps( org.sonatype.nexus.configuration.model.v1_4_4.CProps cProps );
    /**
     * 
     * 
     * @param cRemoteAuthentication
     */
    public org.sonatype.nexus.configuration.model.v1_4_5.CRemoteAuthentication upgradeCRemoteAuthentication( org.sonatype.nexus.configuration.model.v1_4_4.CRemoteAuthentication cRemoteAuthentication );
    /**
     * 
     * 
     * @param cRemoteConnectionSettings
     */
    public org.sonatype.nexus.configuration.model.v1_4_5.CRemoteConnectionSettings upgradeCRemoteConnectionSettings( org.sonatype.nexus.configuration.model.v1_4_4.CRemoteConnectionSettings cRemoteConnectionSettings );
    /**
     * 
     * 
     * @param cRemoteHttpProxySettings
     */
    public org.sonatype.nexus.configuration.model.v1_4_5.CRemoteHttpProxySettings upgradeCRemoteHttpProxySettings( org.sonatype.nexus.configuration.model.v1_4_4.CRemoteHttpProxySettings cRemoteHttpProxySettings );
    /**
     * 
     * 
     * @param cRemoteNexusInstance
     */
    public org.sonatype.nexus.configuration.model.v1_4_5.CRemoteNexusInstance upgradeCRemoteNexusInstance( org.sonatype.nexus.configuration.model.v1_4_4.CRemoteNexusInstance cRemoteNexusInstance );
    /**
     * 
     * 
     * @param cRemoteStorage
     */
    public org.sonatype.nexus.configuration.model.v1_4_5.CRemoteStorage upgradeCRemoteStorage( org.sonatype.nexus.configuration.model.v1_4_4.CRemoteStorage cRemoteStorage );
    /**
     * 
     * 
     * @param cRepository
     */
    public org.sonatype.nexus.configuration.model.v1_4_5.CRepository upgradeCRepository( org.sonatype.nexus.configuration.model.v1_4_4.CRepository cRepository );
    /**
     * 
     * 
     * @param cRepositoryGrouping
     */
    public org.sonatype.nexus.configuration.model.v1_4_5.CRepositoryGrouping upgradeCRepositoryGrouping( org.sonatype.nexus.configuration.model.v1_4_4.CRepositoryGrouping cRepositoryGrouping );
    /**
     * 
     * 
     * @param cRepositoryTarget
     */
    public org.sonatype.nexus.configuration.model.v1_4_5.CRepositoryTarget upgradeCRepositoryTarget( org.sonatype.nexus.configuration.model.v1_4_4.CRepositoryTarget cRepositoryTarget );
    /**
     * 
     * 
     * @param cRestApiSettings
     */
    public org.sonatype.nexus.configuration.model.v1_4_5.CRestApiSettings upgradeCRestApiSettings( org.sonatype.nexus.configuration.model.v1_4_4.CRestApiSettings cRestApiSettings );
    /**
     * 
     * 
     * @param cRouting
     */
    public org.sonatype.nexus.configuration.model.v1_4_5.CRouting upgradeCRouting( org.sonatype.nexus.configuration.model.v1_4_4.CRouting cRouting );
    /**
     * 
     * 
     * @param cScheduleConfig
     */
    public org.sonatype.nexus.configuration.model.v1_4_5.CScheduleConfig upgradeCScheduleConfig( org.sonatype.nexus.configuration.model.v1_4_4.CScheduleConfig cScheduleConfig );
    /**
     * 
     * 
     * @param cScheduledTask
     */
    public org.sonatype.nexus.configuration.model.v1_4_5.CScheduledTask upgradeCScheduledTask( org.sonatype.nexus.configuration.model.v1_4_4.CScheduledTask cScheduledTask );
    /**
     * 
     * 
     * @param cSmtpConfiguration
     */
    public org.sonatype.nexus.configuration.model.v1_4_5.CSmtpConfiguration upgradeCSmtpConfiguration( org.sonatype.nexus.configuration.model.v1_4_4.CSmtpConfiguration cSmtpConfiguration );
    /**
     * 
     * 
     * @param configuration
     */
    public org.sonatype.nexus.configuration.model.v1_4_5.Configuration upgradeConfiguration( org.sonatype.nexus.configuration.model.v1_4_4.Configuration configuration );
}
